--------------------------------------------------------------------------------
-- An example of a combinational circuit   
-- This component may be used as a building block for more complex circuits
-- An active-low decoder 2 to 4
-- Behavioural approach for interpreting the truth table
---------------------------------------------------
-- Project P2  - CSD 
-- http://digsys.upc.edu
--------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

ENTITY  Dec_2_to_4 is

	port(	E 		:	in std_logic;
			X_in	:	in std_logic_vector (1 downto 0);
			Yout_L	:	out std_logic_vector(3 downto 0)
		);
end Dec_2_to_4;

architecture truth_table of Dec_2_to_4 is
      
BEGIN
	PROCESS (E, X_IN)  
		BEGIN
			IF E = '1' THEN
				CASE X_IN IS    		
					WHEN "00" =>       		
						Yout_L <= "1110";
					WHEN "01" =>       		
						Yout_L <= "1101";
					WHEN "10" =>       		
						Yout_L <= "1011";
						WHEN Others =>       		
						Yout_L <= "0111";
				END CASE;
			
			ELSE 
				Yout_L <= "1111";
			END IF;
	
	END PROCESS;

		
end truth_table;