--------------------------------------------------------------------------------
-- An example of Quad_MUX4, quadruple multiplexer of 4 channels with enable
-- This component is like a building block for many other projects 
---------------------------------------------------
-- Project P2  - CSD 
-- http://digsys.upc.edu
--------------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;


ENTITY  Quad_MUX4 is

	port(	E 	:	in std_logic;
			Ch0	:	in std_logic_vector(3 downto 0);
			Ch1	:	in std_logic_vector(3 downto 0);
			Ch2	:	in std_logic_vector(3 downto 0);
			Ch3	:	in std_logic_vector(3 downto 0);
			s	:	in std_logic_vector(1 downto 0);
			y	:	out std_logic_vector(3 downto 0)
		);
end Quad_MUX4;

architecture truth_table of Quad_MUX4 is
begin   

y	<= 	Ch0 when (s ="00" and E = '1') else
		Ch1 when (s ="01" and E = '1') else
		Ch2 when (s ="10" and E = '1') else
		Ch3 when (s ="11" and E = '1') else "0000"; 
		
end truth_table;